<?php

/**
 * Code được mod bởi Phương Bách - s2demon
 * Vui lòng không xóa bản quyền để tôn trọng người viết
 * Tên file: Mod đăng bài viết JohnCMS
 **/

defined('_IN_JOHNCMS') or die('Error: restricted access');

//--- Lỗi khi là khách hoặc không có ID ---//
if (!$id || !$user_id || isset($ban['1']) || isset($ban['11']) || (!core::$user_rights && $set['mod_forum'] == 3)) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['access_forbidden']);
    require('../incfiles/end.php');
    exit;
}


/*
-----------------------------------------------------------------
Вспомогательная Функция обработки ссылок форума
-----------------------------------------------------------------
*/
function forum_link($m)
{
    global $set;
    if (!isset($m[3])) {
        return '[url=' . $m[1] . ']' . $m[2] . '[/url]';
    } else {
        $p = parse_url($m[3]);
        if ('http://' . $p['host'] . $p['path'] . '?id=' == $set['homeurl'] . '/forum/index.php?id=') {
            $thid = abs(intval(preg_replace('/(.*?)id=/si', '', $m[3])));
            $req = mysql_query("SELECT `text` FROM `forum` WHERE `id`= '$thid' AND `type` = 't' AND `close` != '1'");
            if (mysql_num_rows($req) > 0) {
                $res = mysql_fetch_array($req);
                $name = strtr($res['text'], array(
                    '&quot;' => '',
                    '&amp;' => '',
                    '&lt;' => '',
                    '&gt;' => '',
                    '&#039;' => '',
                    '[' => '',
                    ']' => ''
                ));
                if (mb_strlen($name) > 40)
                    $name = mb_substr($name, 0, 40) . '...';
                return '[url=' . $m[3] . ']' . $name . '[/url]';
            } else {
                return $m[3];
            }
        } else
            return $m[3];
    }
}

// Проверка на флуд
$flood = functions::antiflood();
if ($flood) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['error_flood'] . ' ' . $flood . $lng['sec'] . ', <a href="index.php?id=' . $id . '&amp;start=' . $start . '">' . $lng['back'] . '</a>');
    require('../incfiles/end.php');
    exit;
}
$req_r = mysql_query("SELECT * FROM `forum` WHERE `id` = '$id' AND `type` = 'r' LIMIT 1");
if (!mysql_num_rows($req_r)) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['error_wrong_data']);
    require('../incfiles/end.php');
    exit;
}
$th = isset($_POST['th']) ? functions::check(mb_substr(trim($_POST['th']), 0, 100)) : '';
$tit = isset($_POST['tit']) ? functions::check(mb_substr(trim($_POST['tit']), 0, 100)) : '';
$url = isset($_POST['url']) ? functions::check(mb_substr(trim($_POST['url']), 0, 100)) : '';
$msg = isset($_POST['msg']) ? functions::checkin(trim($_POST['msg'])) : '';
if (isset($_POST['msgtrans'])) {
    $th = functions::trans($th);
    $tit = functions::trans($tit);
    $url = functions::trans($url);
    $msg = functions::trans($msg);
}
$msg = preg_replace_callback('~\\[url=(http://.+?)\\](.+?)\\[/url\\]|(http://(www.)?[0-9a-zA-Z\.-]+\.[0-9a-zA-Z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', 'forum_link', $msg);
if (isset($_POST['submit'])
    && isset($_POST['token'])
    && isset($_SESSION['token'])
    && $_POST['token'] == $_SESSION['token']
) {
    $error = array();
    if (empty($th) or empty($tit) or empty($url))
        $error[] = $lng_forum['error_topic_name'];
    if (mb_strlen($th) < 2)
        $error[] = $lng_forum['error_topic_name_lenght'];
    if (empty($msg))
        $error[] = $lng['error_empty_message'];
    if (mb_strlen($msg) < 4)
        $error[] = $lng['error_message_short'];
    if (!$error) {
        $msg = preg_replace_callback('~\\[url=(http://.+?)\\](.+?)\\[/url\\]|(http://(www.)?[0-9a-zA-Z\.-]+\.[0-9a-zA-Z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', 'forum_link', $msg);
        // đã tồn tại topic
        if (mysql_result(mysql_query("SELECT COUNT(*) FROM `forum` WHERE `text` = '$th'"), 0) > 0)
            $error[] = $lng_forum['error_topic_exists'];
        if (mysql_result(mysql_query("SELECT COUNT(*) FROM `forum` WHERE `nametopic` = '$url'"), 0) > 0)
            $error[] = $lng_forum['error_topic_exists'];
        if (mysql_result(mysql_query("SELECT COUNT(*) FROM `forum` WHERE `name` = '$tit'"), 0) > 0)
            $error[] = $lng_forum['error_topic_exists'];
        // đã tồn tại văn bản
        $req = mysql_query("SELECT * FROM `forum` WHERE `user_id` = '$user_id' AND `type` = 's' ORDER BY `time` DESC");
        if (mysql_num_rows($req) > 0) {
            $res = mysql_fetch_array($req);
            if ($msg == $res['text'])
                $error[] = $lng['error_message_exists'];
        }
    }
    if (!$error) {
        unset($_SESSION['token']);
        $ress = mysql_fetch_array(mysql_query("SELECT `refid` FROM `forum` WHERE `id` = '$id' ORDER BY `time` DESC"));
        // Chèn tên bài viết
        mysql_query("INSERT INTO `forum` SET
            `refid` = '$id',
            `type` = 't',
	    `hienthi`='".((isset($_POST['hienthi'])) ? '1' : '0')."',
            `time` = '" . time() . "',
            `user_id` = '$user_id',
            `from` = '$login',
            `text` = '$th',
            `name` = '$tit',
            `nametopic` = '".rw($url)."',
            `regid` = '".$ress['refid']."',
            `soft` = '',
            `img` = '0',
            `edit` = '',
            `curators` = ''
        ") or exit(__LINE__ . ': ' . mysql_error());
        $rid = mysql_insert_id();
        // Chèn nội dung bài viết
$rq = mysql_fetch_array(mysql_query("SELECT `nametopic` FROM `forum` WHERE `id`= '" . $rid. "'"));
if ($_POST['img'] == 1){
$na = $rq['nametopic'];
$msg = img($msg,$na);
$msg = html_entity_decode($msg,ENT_QUOTES,'UTF-8');
}
if ($_POST['imgdd'] == 1){
$na = $rq['nametopic'];
$msg = imgdd($msg,$na);
$msg = html_entity_decode($msg,ENT_QUOTES,'UTF-8');
}

        mysql_query("INSERT INTO `forum` SET
            `refid` = '$rid',
            `type` = 's',
            `time` = '" . time() . "',
            `user_id` = '$user_id',
            `from` = '$login',
            `ip` = '" . core::$ip . "',
            `ip_via_proxy` = '" . core::$ip_via_proxy . "',
            `soft` = '" . mysql_real_escape_string($agn) . "',
            `text` = '" . mysql_real_escape_string($msg) . "',
            `edit` = '',
            `curators` = ''
        ") or exit(__LINE__ . ': ' . mysql_error());
        $postid = mysql_insert_id();
        // Update vào users
        $fpst = $datauser['postforum'] + 1;
        mysql_query("UPDATE `users` SET
            `postforum` = '$fpst',
            `lastpost` = '" . time() . "'
            WHERE `id` = '$user_id'
        ");
        if ($_POST['addfiles'] == 1)
            header("Location: index.php?id=$postid&act=addfile");
        else
            header("Location: ".$home."/".rw($url).".html");
    } else {
        // Thông báo khi có lỗi
        require('../incfiles/head.php');
        echo functions::display_error($error, '<a href="index.php?act=nt&amp;id=' . $id . '">' . $lng['repeat'] . '</a>');
        require('../incfiles/end.php');
        exit;
    }
} else {
    $res_r = mysql_fetch_assoc($req_r);
    $req_c = mysql_query("SELECT * FROM `forum` WHERE `id` = '" . $res_r['refid'] . "'");
    $res_c = mysql_fetch_assoc($req_c);
    require('../incfiles/head.php');
    $msg_pre = functions::checkout($msg, 1, 1);
    if ($set_user['smileys'])
        $msg_pre = functions::smileys($msg_pre, $datauser['rights'] ? 1 : 0);
    $msg_pre = preg_replace('#\[c\](.*?)\[/c\]#si', '<div class="quote">\1</div>', $msg_pre);
    echo '<div class="mainblok"><div class="phdr"><a href="'.$home.'/' . $res_r['nametopic'] . '.html"><b>' . bbcode::tags($res_r['text']) . '</b></a> | ' . $lng_forum['new_topic'] . '</div>';
    echo '<form name="form" action="index.php?act=nt&amp;id=' . $id . '" method="post">' .
        '<div class="list1">' .
        '<p>' . $lng['section'] . '-' .
        '<a href="'.$home.'/' . $res_c['nametopic'] . '.html">' . bbcode::tags($res_c['text']) . '</a> | <a href="'.$home.'/' . $res_r['nametopic'] . '.html">' . bbcode::tags($res_r['text']) . '</a></p>' .
        '<p>Tên hiện ngoài' .
        '<input type="text" size="20" maxlength="100" name="th" value="' . $th . '"/></p>' .
        '<p>Tên title mô tả' .
        '<input type="text" size="20" maxlength="100" name="tit" value="' . $tit . '"/></p>' .
        '<p>Link url' .
        '<input type="text" size="20" maxlength="100" name="url" value="' . $url . '"/></p>' .
        '<p>' . $lng_forum['post'] . '';
    echo '<textarea class="ckeditor" rows="8" name="msg">'.(isset($_POST['msg']) ? functions::checkout($_POST['msg']) : '').'</textarea></p>';
    echo '<p><input type="checkbox" name="addfiles" value="1" ' . (isset($_POST['addfiles']) ? 'checked="checked" ' : '') . '/> ' . $lng_forum['add_file'];
         echo '<br /><input type="checkbox" name="img" value="1" ' . (isset($_POST['img']) ? 'checked="checked" ' : '') . '/> Leech Ảnh về ^-^';
         echo '<br /><input type="checkbox" name="imgdd" value="1" ' . (isset($_POST['imgdd']) ? 'checked="checked" ' : '') . '/> Leech Ảnh Đóng Dấu^-^';
    	echo '<br><input type="checkbox" name="hienthi" value="1"  ' . (isset($_POST['hienthi']) ? 'checked="checked" ' : '') . '/> Hiện Ngoài Menu';
    $token = mt_rand(1000, 100000);
    $_SESSION['token'] = $token;
    echo'</p><p><input type="submit" name="submit" value="' . $lng['save'] . '" style="width: 107px; cursor: pointer;"/> ' .
        '<input type="hidden" name="token" value="' . $token . '"/>' .
        '</p></div></form>' .
        '</div><div class="phdr"><a href="../pages/faq.php?act=trans">' . $lng['translit'] . '</a> | ' .
        '<a href="../pages/faq.php?act=smileys">' . $lng['smileys'] . '</a></div>';
}