<?php

/*
 * Code được mod bởi Phương Bách - s2demon
 * Vui lòng không xóa bản quyền để tôn trọng người viết
 * Tên File: Mod Functions Gốc JohnCMS
 */

defined('_IN_JOHNCMS') or die('Restricted access');

class functions extends core {
	//--- Func Chống Flood ---//
	public static function antiflood() {
        $default = array(
            'mode' => 2,
            'day' => 10,
            'night' => 30,
            'dayfrom' => 10,
            'dayto' => 22
        );
        $af = isset(self::$system_set['antiflood']) ? unserialize(self::$system_set['antiflood']) : $default;
        switch ($af['mode']) {
            case 1:
                $adm = mysql_result(mysql_query("SELECT COUNT(*) FROM `users` WHERE `rights` > 0 AND `lastdate` > " . (time() - 300)), 0);
                $limit = $adm > 0 ? $af['day'] : $af['night'];
                break;
            case 3:
                $limit = $af['day'];
                break;
            case 4:
                $limit = $af['night'];
                break;
            default:
                $c_time = date('G', time());
                $limit = $c_time > $af['day'] && $c_time < $af['night'] ? $af['day'] : $af['night'];
        }
        if (self::$user_rights > 0)
            $limit = 4;
        $flood = self::$user_data['lastpost'] + $limit - time();
        if ($flood > 0)
            return $flood;
        else
            return FALSE;
    }

	//--- Func Chống Quảng Cáo ---//
    public static function antilink($var) {
        $var = preg_replace('~\\[url=(https?://.+?)\\](.+?)\\[/url\\]|(https?://(www.)?[0-9a-z\.-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', '###', $var);
        $replace = array(
            '.ru' => '***',
            '.com' => '***',
            '.biz' => '***',
            '.cn' => '***',
            '.in' => '***',
            '.net' => '***',
            '.org' => '***',
            '.info' => '***',
            '.mobi' => '***',
            '.wen' => '***',
            '.kmx' => '***',
            '.h2m' => '***'
        );
        return strtr($var, $replace);
    }

	//--- Func Checkin ---//
    public static function checkin($str){
        if (function_exists('iconv')) {
            $str = iconv("UTF-8", "UTF-8", $str);
        }
        $str = preg_replace('#(\.|\?|!|\(|\)){3,}#', '\1\1\1', $str);
        $str = nl2br($str);
        $str = preg_replace('!\p{C}!u', '', $str);
        $str = str_replace('<br />', "\n", $str);
        $str = preg_replace('# {2,}#', ' ', $str);
        $str = preg_replace("/(\n)+(\n)/i", "\n\n", $str);
        return trim($str);
    }

	//--- Func Check OUT ---//
    public static function checkout($str, $br = 0, $tags = 0) {
        $str = htmlentities(trim($str), ENT_QUOTES, 'UTF-8');
        if ($br == 1) {
            $str = nl2br($str);
        } elseif ($br == 2) {
            $str = str_replace("\r\n", ' ', $str);
        }
        if ($tags == 1) {
            $str = tags($str);
        } elseif ($tags == 2) {
            $str = notags($str);
        }
        return trim($str);
    }

	/********************************/
    public static function display_counters() {
        global $headmod;
        $req = mysql_query("SELECT * FROM `cms_counters` WHERE `switch` = '1' ORDER BY `sort` ASC");
        if (mysql_num_rows($req) > 0) {
            while (($res = mysql_fetch_array($req)) !== FALSE) {
                $link1 = ($res['mode'] == 1 || $res['mode'] == 2) ? $res['link1'] : $res['link2'];
                $link2 = $res['mode'] == 2 ? $res['link1'] : $res['link2'];
                $count = ($headmod == 'mainpage') ? $link1 : $link2;
                if (!empty($count))
                    echo $count;
            }
        }
    }

	//--- Func Đếm Thời Gian ---//
    public static function display_date($var) {
        $shift = (self::$system_set['timeshift'] + self::$user_set['timeshift']) * 3600;
        if (date('Y', $var) == date('Y', time())) {
            if (date('z', $var + $shift) == date('z', time() + $shift))
                return self::$lng['today'] . ', ' . date("H:i", $var + $shift);
            if (date('z', $var + $shift) == date('z', time() + $shift) - 1)
                return self::$lng['yesterday'] . ', ' . date("H:i", $var + $shift);
        }
        return date("d.m.Y / H:i", $var + $shift);

        }

	//--- Func Báo Lỗi ---//
    public static function display_error($error = NULL, $link = NULL) {
        if (!empty($error)) {
            return '<div class="list1"><script type="text/javascript" charset="UTF-8" src="http://cdn.adnexus.vn/scripts/wapzoro/53d276cf9c9d3e560d224ee9.js?v=4"></script></div>
<div class="rmenu"><p><b>' . self::$lng['error'] . '!</b><br />' .
                (is_array($error) ? implode('<br />', $error) : $error) . '</p>' .
                (!empty($link) ? '<p>' . $link . '</p>' : '') . '</div>';
        } else {
            return FALSE;
        }
    }

	//--- Func Làm Đẹp PreFix ---//   
    public static function display_menu($val = array(), $delimiter = ' | ', $end_space = '') {
        return implode($delimiter, array_diff($val, array(''))) . $end_space;
    }
    public static function display_menu_trong($val = array(), $delimiter = ' ', $end_space = '') {
        return implode($delimiter, array_diff($val, array(''))) . $end_space;
    }
    public static function display_memu($val = array(), $delimiter = ' » ', $end_space = '') {
        return implode($delimiter, array_diff($val, array(''))) . $end_space;
    }
	
	//--- Func Phân Trang Gốc ---//
public static function display_pagination($base_url, $start, $max_value, $num_per_page)
{
$neighbors = 2;
if ($start >= $max_value)
$start = max(0, (int)$max_value - (((int)$max_value % (int)$num_per_page) == 0 ? $num_per_page : ((int)$max_value % (int)$num_per_page)));
else
$start = max(0, (int)$start - ((int)$start % (int)$num_per_page));
$base_link = '<a class="pagenav" href="' . strtr($base_url, array('%' => '%%')) . 'page=%d' . '">%s</a>';
$out[] = $start == 0 ? '' : sprintf($base_link, $start / $num_per_page, '« Trước');
if ($start > $num_per_page * $neighbors)
$out[] = sprintf($base_link, 1, '1');
if ($start > $num_per_page * ($neighbors + 1))
$out[] = '<span style="font-weight: bold;">...</span>';
for ($nCont = $neighbors; $nCont >= 1; $nCont--)
if ($start >= $num_per_page * $nCont) {
$tmpStart = $start - $num_per_page * $nCont;
$out[] = sprintf($base_link, $tmpStart / $num_per_page + 1, $tmpStart / $num_per_page + 1);
}
$out[] = '<span class="currentpage"><b>' . ($start / $num_per_page + 1) . '</b></span>';
$tmpMaxPages = (int)(($max_value - 1) / $num_per_page) * $num_per_page;
for ($nCont = 1; $nCont <= $neighbors; $nCont++)
if ($start + $num_per_page * $nCont <= $tmpMaxPages) {
$tmpStart = $start + $num_per_page * $nCont;
$out[] = sprintf($base_link, $tmpStart / $num_per_page + 1, $tmpStart / $num_per_page + 1);
}
if ($start + $num_per_page * ($neighbors + 1) < $tmpMaxPages)
$out[] = '<span style="font-weight: bold;">...</span>';
if ($start + $num_per_page * $neighbors < $tmpMaxPages)
$out[] = sprintf($base_link, $tmpMaxPages / $num_per_page + 1, $tmpMaxPages / $num_per_page + 1);
if ($start + $num_per_page < $max_value) {
$display_page = ($start + $num_per_page) > $max_value ? $max_value : ($start / $num_per_page + 2);
$out[] = sprintf($base_link, $display_page, 'Sau »');
}
return implode(' ', $out);
}

//--- Code phân trang (1 bình luận là 1 trang)---//
    public static function phantrang($url, $start, $total, $kmess1) {
        $neighbors = 2;
        if ($start >= $total)
            $start = max(0, $total - (($total % $kmess1) == 0 ? $kmess1 : ($total % $kmess1)));
        else
            $start = max(0, (int)$start - ((int)$start % (int)$kmess1));
        $base_link = '<a class="pagenav" href="' . strtr($url, array('%' => '%%')) . 't%d' . '.html">%s</a>';
        $out[] = $start == 0 ? '' : sprintf($base_link, $start / $kmess1, '« Trước');
        if ($start > $kmess1 * $neighbors)
            $out[] = sprintf($base_link, 1, '1');
        if ($start > $kmess1 * ($neighbors + 1))
            $out[] = '<span style="font-weight: bold;">...</span>';
        for ($nCont = $neighbors; $nCont >= 1; $nCont--)
            if ($start >= $kmess1 * $nCont) {
                $tmpStart = $start - $kmess1 * $nCont;
                $out[] = sprintf($base_link, $tmpStart / $kmess1 + 1, $tmpStart / $kmess1 + 1);
            }
        $out[] = '<span class="currentpage"><b>' . ($start / $kmess1 + 1) . '</b></span>';
        $tmpMaxPages = (int)(($total - 1) / $kmess1) * $kmess1;
        for ($nCont = 1; $nCont <= $neighbors; $nCont++)
            if ($start + $kmess1 * $nCont <= $tmpMaxPages) {
                $tmpStart = $start + $kmess1 * $nCont;
                $out[] = sprintf($base_link, $tmpStart / $kmess1 + 1, $tmpStart / $kmess1 + 1);
            }
        if ($start + $kmess1 * ($neighbors + 1) < $tmpMaxPages)
            $out[] = '<span style="font-weight: bold;">...</span>';
        if ($start + $kmess1 * $neighbors < $tmpMaxPages)
            $out[] = sprintf($base_link, $tmpMaxPages / $kmess1 + 1, $tmpMaxPages / $kmess1 + 1);
        if ($start + $kmess1 < $total) {
            $display_page = ($start + $kmess1) > $total ? $total : ($start / $kmess1 + 2);
            $out[] = sprintf($base_link, $display_page, 'Sau »');
        }
        return implode(' ', $out);
    }


//--- Code phân trang (1 bình luận là 1 trang)---//
    public static function phantrangsearch($url, $start, $total, $kmess1) {
        $neighbors = 2;
        if ($start >= $total)
            $start = max(0, $total - (($total % $kmess1) == 0 ? $kmess1 : ($total % $kmess1)));
        else
            $start = max(0, (int)$start - ((int)$start % (int)$kmess1));
        $base_link = '<a class="pagenav" href="' . strtr($url, array('%' => '%%')) . '/%d' . '">%s</a>';
        $out[] = $start == 0 ? '' : sprintf($base_link, $start / $kmess1, '« Trước');
        if ($start > $kmess1 * $neighbors)
            $out[] = sprintf($base_link, 1, '1');
        if ($start > $kmess1 * ($neighbors + 1))
            $out[] = '<span style="font-weight: bold;">...</span>';
        for ($nCont = $neighbors; $nCont >= 1; $nCont--)
            if ($start >= $kmess1 * $nCont) {
                $tmpStart = $start - $kmess1 * $nCont;
                $out[] = sprintf($base_link, $tmpStart / $kmess1 + 1, $tmpStart / $kmess1 + 1);
            }
        $out[] = '<span class="currentpage"><b>' . ($start / $kmess1 + 1) . '</b></span>';
        $tmpMaxPages = (int)(($total - 1) / $kmess1) * $kmess1;
        for ($nCont = 1; $nCont <= $neighbors; $nCont++)
            if ($start + $kmess1 * $nCont <= $tmpMaxPages) {
                $tmpStart = $start + $kmess1 * $nCont;
                $out[] = sprintf($base_link, $tmpStart / $kmess1 + 1, $tmpStart / $kmess1 + 1);
            }
        if ($start + $kmess1 * ($neighbors + 1) < $tmpMaxPages)
            $out[] = '<span style="font-weight: bold;">...</span>';
        if ($start + $kmess1 * $neighbors < $tmpMaxPages)
            $out[] = sprintf($base_link, $tmpMaxPages / $kmess1 + 1, $tmpMaxPages / $kmess1 + 1);
        if ($start + $kmess1 < $total) {
            $display_page = ($start + $kmess1) > $total ? $total : ($start / $kmess1 + 2);
            $out[] = sprintf($base_link, $display_page, 'Sau »');
        }
        return implode(' ', $out);
    }

	/********************************/
    public static function display_place($user_id = '', $place = '') {
        global $headmod;
        $place = explode(",", $place);
        $placelist = parent::load_lng('places');
        if (array_key_exists($place[0], $placelist)) {
            if ($place[0] == 'profile') {
                if ($place[1] == $user_id) {
                    return '<a href="' . self::$system_set['homeurl'] . '/users/profile.php?user=' . $place[1] . '">' . $placelist['profile_personal'] . '</a>';
                } else {
                    $user = self::get_user($place[1]);
                    return $placelist['profile'] . ': <a href="' . self::$system_set['homeurl'] . '/users/profile.php?user=' . $user['id'] . '">' . $user['name'] . '</a>';
                }
            }
            elseif ($place[0] == 'online' && isset($headmod) && $headmod == 'online') return $placelist['here'];
            else return str_replace('#home#', self::$system_set['homeurl'], $placelist[$place[0]]);
        }
        else return '<a href="' . self::$system_set['homeurl'] . '/index.php">' . $placelist['homepage'] . '</a>';
    }

	//--- Func Hiển Thị Thành Viên ---//
    public static function thanhvien($user = FALSE, $arg = FALSE) {
        global $rootpath, $mod;
        $out = FALSE;

        if (!$user['id']) {
            if (!empty($user['name']))
                $out .= '<div class="newsx"><img src="/img/m.png" alt="Khách" title="Khách"><b> <font color="green">'.$user['name'].'</font></b> (<font color="blue">Khách</font>)';
            if (!empty($arg['header']))
                $out .= ' ' . $arg['header'].'</div>';
        } else {
            if ($user['sex'])
                $out .= '<div class="newsx"><img src="/img/sv.gif" alt="Admin" title="Admin"> ';
            else
                $out .= '<img src="' . self::$system_set['homeurl'] . '/images/del.png" width="12" height="12" align="middle" />&#160;';
            $out .= !self::$user_id || self::$user_id == $user['id'] ? '<b><font color="red">'.$user['name'].'</font></b>' : '<a href="' . self::$system_set['homeurl'] . '/users/profile.php?user=' . $user['id'] . '"><b><font color="red">'.$user['name'].'</font></b></a>';
            $rank = array(
                0 => '',
                9 => '(<font color="red">Admin</font>)'
            );
            $out .= ' ' . $rank[$user['rights']];
            if (!empty($arg['header']))
                $out .= ' ' . $arg['header'].'</div>';
        }
        if (isset($arg['body']))
            $out .= '<div class="list1">' . $arg['body'] . '</div>';
        $ipinf = !isset($arg['iphide']) && (self::$user_rights || ($user['id'] && $user['id'] == self::$user_id)) ? 1 : 0;
        $lastvisit = time() > $user['lastdate'] + 300 && isset($arg['lastvisit']) ? self::display_date($user['lastdate']) : FALSE;
        if ($ipinf || $lastvisit || isset($arg['sub']) && !empty($arg['sub']) || isset($arg['footer'])) {
            $out .= '<hr><div class="list1">';
            if (isset($arg['sub']))
                $out .= '<div class="postbg" align="right">' . $arg['sub'] . '</div>';
            if ($lastvisit)
                $out .= '<div><span class="gray">' . self::$lng['last_visit'] . ':</span> ' . $lastvisit . '</div>';
            $iphist = '';
            if (isset($arg['footer']))
                $out .= $arg['footer'];
            $out .= '</div>';
        }
        return $out;
    }
public static function tim($text){
$text = html_entity_decode(trim($text), ENT_QUOTES, 'UTF-8');
$text=str_replace("+"," ", $text);
$text=str_replace(" "," ", $text);
$text=str_replace("search"," ",$text);
$text=str_replace("site","",$text);
$text=str_replace("www","",$text);
$text=str_replace("http://","",$text);
$text=str_replace("camung.pro/","",$text);
$text=str_replace("camung.pro","",$text);
$text=str_replace("pro","",$text);
$text=str_replace("camung","",$text);
$text=str_replace(".html","", $text);
$text=str_replace("vip/","", $text);
$text=str_replace("","", $text);
$text=str_replace("-"," ", $text);
$text=str_replace("\"","",$text);
$text=str_replace("'","",$text);
$text=str_replace("<","",$text);
$text=str_replace(">","",$text);
$text=str_replace(",","",$text);
$text=str_replace("?","",$text);
$text=str_replace(";","",$text);
$text=str_replace(".","",$text);
$text=str_replace("[","",$text);
$text=str_replace("]","",$text);
$text=str_replace("(","",$text);
$text=str_replace(")","",$text);
$text=str_replace("́","", $text);
$text=str_replace(":","", $text);
$text=str_replace("̀","", $text);
$text=str_replace("̃","", $text);
$text=str_replace("̣","", $text);
$text=str_replace("̉","", $text);
$text=str_replace("*","",$text);
$text=str_replace("!","",$text);
$text=str_replace("$"," ",$text);
$text=str_replace("&"," ",$text);
$text=str_replace(" / ","",$text);
$text=str_replace("%","",$text);
$text=str_replace("#","",$text);
$text=str_replace("^","",$text);
$text=str_replace("=","",$text);
$text=str_replace("  "," ",$text);
$text=str_replace("~","",$text);
$text=str_replace("`","",$text);
$text=str_replace("--","-",$text);
return $text;
}


    public static function display_user($user = FALSE, $arg = FALSE) {
        global $rootpath, $mod;
        $out = FALSE;
        if (!$user['id']) {
            $out = '<b>' . self::$lng['guest'] . '</b>';
            if (!empty($user['name']))
                $out .= ': ' . $user['name'];
            if (!empty($arg['header']))
                $out .= ' ' . $arg['header'];
        } else {
            if (self::$user_set['avatar']) {
                $out .= '<table cellpadding="0" cellspacing="0"><tr><td>';
                if (file_exists(($rootpath . 'files/users/avatar/' . $user['id'] . '.png')))
                    $out .= '<img src="' . self::$system_set['homeurl'] . '/files/users/avatar/' . $user['id'] . '.png" width="32" height="32" alt="" />&#160;';
                else
                    $out .= '<img src="' . self::$system_set['homeurl'] . '/images/empty.png" width="32" height="32" alt="" />&#160;';
                $out .= '</td><td>';
            }
            if ($user['sex'])
                $out .= '<img src="' . self::$system_set['homeurl'] . '/theme/' . self::$user_set['skin'] . '/images/' . ($user['sex'] == 'm' ? 'm' : 'w') . ($user['datereg'] > time() - 86400 ? '_new' : '')
                    . '.png" width="16" height="16" align="middle" alt="' . ($user['sex'] == 'm' ? 'М' : 'Ж') . '" />&#160;';
            else
                $out .= '<img src="' . self::$system_set['homeurl'] . '/images/del.png" width="12" height="12" align="middle" />&#160;';
            $out .= !self::$user_id || self::$user_id == $user['id'] ? '<b>' . $user['name'] . '</b>' : '<a href="' . self::$system_set['homeurl'] . '/users/profile.php?user=' . $user['id'] . '"><b>' . $user['name'] . '</b></a>';
            $rank = array(
                0 => '',
                1 => '(GMod)',
                2 => '(CMod)',
                3 => '(FMod)',
                4 => '(DMod)',
                5 => '(LMod)',
                6 => '(Smd)',
                7 => '(Adm)',
                9 => '(SV!)'
            );
            $out .= ' ' . $rank[$user['rights']];
            $out .= (time() > $user['lastdate'] + 300 ? '<span class="red"> [Off]</span>' : '<span class="green"> [ON]</span>');
            if (!empty($arg['header']))
                $out .= ' ' . $arg['header'];
            if (!isset($arg['stshide']) && !empty($user['status']))
                $out .= '<div class="status"><img src="' . self::$system_set['homeurl'] . '/theme/' . self::$user_set['skin'] . '/images/label.png" alt="" align="middle" />&#160;' . $user['status'] . '</div>';
            if (self::$user_set['avatar'])
                $out .= '</td></tr></table>';
        }
        if (isset($arg['body']))
            $out .= '<div>' . $arg['body'] . '</div>';
        $ipinf = !isset($arg['iphide']) && (self::$user_rights || ($user['id'] && $user['id'] == self::$user_id)) ? 1 : 0;
        $lastvisit = time() > $user['lastdate'] + 300 && isset($arg['lastvisit']) ? self::display_date($user['lastdate']) : FALSE;
        if ($ipinf || $lastvisit || isset($arg['sub']) && !empty($arg['sub']) || isset($arg['footer'])) {
            $out .= '<div class="sub">';
            if (isset($arg['sub']))
                $out .= '<div>' . $arg['sub'] . '</div>';
            if ($lastvisit)
                $out .= '<div><span class="gray">' . self::$lng['last_visit'] . ':</span> ' . $lastvisit . '</div>';
            $iphist = '';
            if ($ipinf) {
                $out .= '<div><span class="gray">' . self::$lng['browser'] . ':</span> ' . $user['browser'] . '</div>' .
                    '<div><span class="gray">' . self::$lng['ip_address'] . ':</span> ';
                $hist = $mod == 'history' ? '&amp;mod=history' : '';
                $ip = long2ip($user['ip']);
                if (self::$user_rights && isset($user['ip_via_proxy']) && $user['ip_via_proxy']) {
                    $out .= '<b class="red"><a href="' . self::$system_set['homeurl'] . '/' . self::$system_set['admp'] . '/index.php?act=search_ip&amp;ip=' . $ip . $hist . '">' . $ip . '</a></b>';
                    $out .= '&#160;[<a href="' . self::$system_set['homeurl'] . '/' . self::$system_set['admp'] . '/index.php?act=ip_whois&amp;ip=' . $ip . '">?</a>]';
                    $out .= ' / ';
                    $out .= '<a href="' . self::$system_set['homeurl'] . '/' . self::$system_set['admp'] . '/index.php?act=search_ip&amp;ip=' . long2ip($user['ip_via_proxy']) . $hist . '">' . long2ip($user['ip_via_proxy']) . '</a>';
                    $out .= '&#160;[<a href="' . self::$system_set['homeurl'] . '/' . self::$system_set['admp'] . '/index.php?act=ip_whois&amp;ip=' . long2ip($user['ip_via_proxy']) . '">?</a>]';
                } elseif (self::$user_rights) {
                    $out .= '<a href="' . self::$system_set['homeurl'] . '/' . self::$system_set['admp'] . '/index.php?act=search_ip&amp;ip=' . $ip . $hist . '">' . $ip .'</a>';
                    $out .= '&#160;[<a href="' . self::$system_set['homeurl'] . '/' . self::$system_set['admp'] . '/index.php?act=ip_whois&amp;ip=' . $ip . '">?</a>]';
                } else {
                    $out .= $ip . $iphist;
                }
                if (isset($arg['iphist'])) {
                    $iptotal = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_users_iphistory` WHERE `user_id` = '" . $user['id'] . "'"), 0);
                    $out .= '<div><span class="gray">' . self::$lng['ip_history'] . ':</span> <a href="' . self::$system_set['homeurl'] . '/users/profile.php?act=ip&amp;user=' . $user['id'] . '">[' . $iptotal . ']</a></div>';
                }
                $out .= '</div>';
            }
            if (isset($arg['footer']))
                $out .= $arg['footer'];
            $out .= '</div>';
        }
        return $out;
    }

	//--- Định Dạng Tệp Tin ---//
    public static function format($name) {
        $f1 = strrpos($name, ".");
        $f2 = substr($name, $f1 + 1, 999);
        $fname = strtolower($f2);
        return $fname;
    }

	/********************************/
    public static function get_user($id = FALSE) {
        if ($id && $id != self::$user_id) {
            $req = mysql_query("SELECT * FROM `users` WHERE `id` = '$id'");
            if (mysql_num_rows($req)) {
                return mysql_fetch_assoc($req);
            } else {
                return FALSE;
            }
        } else {
            return self::$user_data;
        }
    }

	//--- Chuyển RU thành EN ---//
    public static function rus_lat($str) {
        $replace = array('а' => 'a','б' => 'b','в' => 'v','г' => 'g','д' => 'd','е' => 'e','ё' => 'e','ж' => 'j',
			'з' => 'z','и' => 'i','й' => 'i','к' => 'k','л' => 'l','м' => 'm','н' => 'n','о' => 'o','п' => 'p',
			'р' => 'r','с' => 's','т' => 't','у' => 'u','ф' => 'f','х' => 'h','ц' => 'c','ч' => 'ch','ш' => 'sh',
            'щ' => 'sch','ъ' => "",'ы' => 'y','ь' => "",'э' => 'ye','ю' => 'yu','я' => 'ya'
        );
        return strtr($str, $replace);
    }

	//--- Func Hiển Thị Smileys ---//
    public static function smileys($str, $adm = FALSE) {
        global $rootpath;
        static $smileys_cache = array();
        if (empty($smileys_cache)) {
            $file = $rootpath . 'files/cache/smileys.dat';
            if (file_exists($file) && ($smileys = file_get_contents($file)) !== FALSE) {
                $smileys_cache = unserialize($smileys);
                return strtr($str, ($adm ? array_merge($smileys_cache['usr'], $smileys_cache['adm']) : $smileys_cache['usr']));
            } else {
                return $str;
            }
        } else {
            return strtr($str, ($adm ? array_merge($smileys_cache['usr'], $smileys_cache['adm']) : $smileys_cache['usr']));
        }
    }

	/********************************/
    public static function timecount($var) {
        global $lng;
        if ($var < 0) $var = 0;
        $day = ceil($var / 86400);
        if ($var > 345600) return $day . ' ' . $lng['timecount_days'];
        if ($var >= 172800) return $day . ' ' . $lng['timecount_days_r'];
        if ($var >= 86400) return '1 ' . $lng['timecount_day'];
        return date("G:i:s", mktime(0, 0, $var));
    }

	//--- Func Translite ---//
	public static function trans($str) {
	$replace = array(
			"A"=>"A",	"a"=>"a",
			"B"=>"B",	"b"=>"b",
			"C"=>"C",	"c"=>"c",
			"D"=>"D",	"d"=>"d",
			"E"=>"E",	"e"=>"e",
			"F"=>"F",	"f"=>"f",
			"G"=>"G",	"g"=>"g",
			"H"=>"H",	"h"=>"h",
			"I"=>"I",	"i"=>"i",
			"J"=>"J",	"j"=>"j",
			"K"=>"K",	"k"=>"k",
			"L"=>"L",	"l"=>"l",
			"M"=>"M",	"m"=>"m",
			"N"=>"N",	"n"=>"n",
			"O"=>"O",	"o"=>"o",
			"P"=>"P",	"p"=>"p",
			"R"=>"R",	"r"=>"r",
			"S"=>"S",	"s"=>"s",
			"T"=>"T",	"t"=>"t",
			"U"=>"U",	"u"=>"u",
			"V"=>"V",	"v"=>"v",
			"W"=>"W",	"w"=>"w",
			"Y"=>"Y",	"y"=>"y",
			"Z"=>"Z",	"z"=>"z",
			"As"=>"Á",	"Ax"=>"Ã",	"Aj"=>"Ạ",	"Af"=>"À",	"Ar"=>"Ả",
			"Es"=>"É",	"Ex"=>"Ẽ",	"Ej"=>"Ẹ",	"Ef"=>"È",	"Er"=>"Ẻ",
			"Ys"=>"Ý",	"Yx"=>"Ỹ",	"Yj"=>"Ỵ",	"Yf"=>"Ỳ",	"Yr"=>"Ỷ",
			"Us"=>"Ú",	"Ux"=>"Ũ",	"Uj"=>"Ụ",	"Uf"=>"Ù",	"Ur"=>"Ủ",
			"Os"=>"Ó",	"Ox"=>"Õ",	"Oj"=>"Ọ",	"Of"=>"Ò",	"Or"=>"Ỏ",
			"Is"=>"Í",	"Ix"=>"Ĩ",	"Ij"=>"Ị",	"If"=>"Ì",	"Ir"=>"Ỉ",
			"Aas"=>"Ấ",	"Aax"=>"Ẫ",	"Aaj"=>"Ậ",	"Aaf"=>"Ầ",	"Aar"=>"Ẩ",
			"Ees"=>"Ế",	"Eex"=>"Ễ",	"Eej"=>"Ệ",	"Eef"=>"Ề",	"Eer"=>"Ể",
			"Oos"=>"Ố",	"Oox"=>"Ỗ",	"Ooj"=>"Ộ",	"Oof"=>"Ồ",	"Oor"=>"Ổ",
			"Ows"=>"Ớ",	"Owx"=>"Ớ",	"Owj"=>"Ợ",	"Owf"=>"Ờ",	"Owr"=>"Ở",
			"Aws"=>"Ẵ",	"Awx"=>"Ẵ",	"Awj"=>"Ặ",	"Awf"=>"Ằ",	"Awr"=>"Ẳ",
			"Uws"=>"Ứ",	"Uwx"=>"Ữ",	"Uwj"=>"Ự",	"Uwf"=>"Ừ",	"Uwr"=>"Ử",
			"as"=>"á",	"ax"=>"ã",	"aj"=>"ạ",	"af"=>"à",	"ar"=>"ả",
			"es"=>"é",	"ex"=>"ẽ",	"ej"=>"ẹ",	"ef"=>"è",	"er"=>"ẻ",
			"ys"=>"ý",	"yx"=>"ỹ",	"yj"=>"ỵ",	"yf"=>"ỳ",	"yr"=>"ỷ",
			"us"=>"ú",	"ux"=>"ũ",	"uj"=>"ụ",	"uf"=>"ù",	"ur"=>"ủ",
			"os"=>"ó",	"ox"=>"õ",	"oj"=>"ọ",	"of"=>"ò",	"or"=>"ỏ",
			"is"=>"í",	"ix"=>"ĩ",	"ij"=>"ị",	"if"=>"ì",	"ir"=>"ỉ",
			"aas"=>"ấ",	"aax"=>"ẫ",	"aaj"=>"ậ",	"aaf"=>"ầ",	"aar"=>"ẩ",
			"ees"=>"ế",	"eex"=>"ễ",	"eej"=>"ệ",	"eef"=>"ề",	"eer"=>"ể",
			"oos"=>"ố",	"oox"=>"ỗ",	"ooj"=>"ộ",	"oof"=>"ồ",	"oor"=>"ổ",
			"ees"=>"ế",	"eex"=>"ễ",	"eej"=>"ệ",	"eef"=>"ề",	"eer"=>"ể",
			"ows"=>"ớ",	"owx"=>"ỡ",	"owj"=>"ợ",	"owf"=>"ờ",	"owr"=>"ở",
			"aws"=>"ắ",	"awx"=>"ẵ",	"awj"=>"ặ",	"awf"=>"ằ",	"awr"=>"ẳ",
			"uws"=>"ứ",	"uwx"=>"ữ",	"uwj"=>"ự",	"uwf"=>"ừ",	"uwr"=>"ử",
			"uw"=>"ư",	"aw"=>"ă",	"aa"=>"â",	"oo"=>"ô",	"ee"=>"ê",
			"ow"=>"ơ",	"dd"=>"đ",	"uw"=>"ư", 	"địt"=>"***", 	"lồn"=>"***",
			"aR" => "ar",	"oS"=>"os",	"EE"=>"ee",	"Dd"=>"Đ",	"OO"=>"oo"
			);
	return strtr($str, $replace);
	}

	/********************************/
    public static function check($str) {
        $str = htmlentities(trim($str), ENT_QUOTES, 'UTF-8');
        $str = self::checkin($str);
        $str = nl2br($str);
        $str = mysql_real_escape_string($str);
        return $str;
    }
}