<?php

/**
 * Code được mod bởi Phương Bách - s2demon
 * Vui lòng không xóa bản quyền để tôn trọng người viết
 **/

defined('_IN_JOHNCMS') or die('Error: restricted access');
//Error_Reporting(E_ALL & ~E_NOTICE);
@ini_set('session.use_trans_sid', '0');
@ini_set('arg_separator.output', '&amp;');
date_default_timezone_set('UTC');
mb_internal_encoding('UTF-8');
$rootpath = isset($rootpath) ? $rootpath : '../';

//--- Load các file trong thư mục Classes ---//
spl_autoload_register('autoload');
function autoload($name) {
    global $rootpath;
    $file = $rootpath . 'incfiles/classes/' . $name . '.php';
    if (file_exists($file))
        require_once($file);
}

/*
-----------------------------------------------------------------
Инициализируем Ядро системы
-----------------------------------------------------------------
*/
$core = new core() or die('Error: Core System');
unset($core);

//--- Mặc định ---//
$ip = core::$ip;                                          // IP
$agn = core::$user_agent;                                 // Trình duyệt
$set = core::$system_set;                                 // Cài đặt
$lng = core::$lng;                                        // Ngôn ngữ
$is_mobile = core::$is_mobile;                            // Thiết bị
$home = $set['homeurl'];                                  // Trang chủ

//--- Của thành viên ---//
$user_id = core::$user_id;                                // ID thành viên
$rights = core::$user_rights;                             // Right thành viên
$datauser = core::$user_data;                             // Gọi từ data
$set_user = core::$user_set;                              // Cài đặt của thành viên
$ban = core::$user_ban;                                   // K.I.A
$login = isset($datauser['name']) ? $datauser['name'] : false;
$kmess = $set_user['kmess'] > 4 && $set_user['kmess'] < 100 ? $set_user['kmess'] : 10;
$kmess1 = 1;

function validate_referer() {
    if($_SERVER['REQUEST_METHOD']!=='POST') return;
    if(@!empty($_SERVER['HTTP_REFERER'])) {
        $ref = parse_url(@$_SERVER['HTTP_REFERER']);
        if($_SERVER['HTTP_HOST']===$ref['host']) return;
    }
    die('Invalid request');
}

if ($rights) {
    validate_referer();
}

//--- Khai báo id, name, act, page... ---//
$name = isset($_REQUEST['name']) ? trim($_REQUEST['name']) : '';
$sub = isset($_REQUEST['sub']) ? trim($_REQUEST['sub']) : '';
$subname = isset($_REQUEST['subname']) ? trim($_REQUEST['subname']) : '';
$id = isset($_REQUEST['id']) ? abs(intval($_REQUEST['id'])) : false;
$user = isset($_REQUEST['user']) ? abs(intval($_REQUEST['user'])) : false;
$act = isset($_REQUEST['act']) ? trim($_REQUEST['act']) : '';
$mod = isset($_REQUEST['mod']) ? trim($_REQUEST['mod']) : '';
$do = isset($_REQUEST['do']) ? trim($_REQUEST['do']) : false;
$page = isset($_REQUEST['page']) && $_REQUEST['page'] > 0 ? intval($_REQUEST['page']) : 1;
$pages = isset($_REQUEST['pages']) && $_REQUEST['pages'] > 0 ? intval($_REQUEST['pages']) : 1;
$start = isset($_REQUEST['page']) ? $page * $kmess - $kmess : (isset($_GET['start']) ? abs(intval($_GET['start'])) : 0);
$start1 = isset($_REQUEST['page']) ? $page * $kmess1 - $kmess1 : (isset($_GET['start1']) ? abs(intval($_GET['start1'])) : 0);
$headmod = isset($headmod) ? $headmod : 'mainpage';

//--- Nén trang ---//
if(!isset($set['gzip'])) {
    mysql_query("INSERT INTO `cms_settings` SET `key` = 'gzip', `val` = '1'");
    $set['gzip'] = 1;
}
if ($set['gzip'] && @extension_loaded('zlib')) {
    @ini_set('zlib.output_compression_level', 3);
    ob_start('ob_gzhandler');
} else {
    ob_start();
}

//--- Mod thêm ---//
include'mod/func.php';
include'bbcode.php';
include'mod/trinhduyet.php';
$agn = ua();
$agn = str_replace('/', ' ', $agn);
?>