<?php

/**
 * @package     JohnCMS
 * @link        http://johncms.com
 * @copyright   Copyright (C) 2008-2011 JohnCMS Community
 * @license     LICENSE.txt (see attached file)
 * @version     VERSION.txt (see attached file)
 * @author      http://johncms.com/about
 */

@ini_set("max_execution_time", "600");
define('_IN_JOHNCMS', 1);
define('_IN_JOHNADM', 1);

require('../incfiles/core.php');
$lng = array_merge($lng, core::load_lng('admin'));

// Проверяем права доступа
if (core::$user_rights < 1) {
    header('Location: /?err');
    exit;
}

$headmod = 'admin';
$textl = $lng['admin_panel'];
require('../incfiles/head.php');
$array = array(
    'forum',
    'news',
    'ads',
    'languages',
    'settings',
    'smileys',
    'access',
    'antispy',
    'ipban',
    'quangcao'
);
if ($act && ($key = array_search($act, $array)) !== false && file_exists('includes/' . $array[$key] . '.php')) {
    require('includes/' . $array[$key] . '.php');
} else {
    $regtotal = mysql_result(mysql_query("SELECT COUNT(*) FROM `users` WHERE `preg`='0'"), 0);
    $bantotal = mysql_result(mysql_query("SELECT COUNT(*) FROM `cms_ban_users` WHERE `ban_time` > '" . time() . "'"), 0);
    echo '<div class="mainblok"><div class="phdr"><b>' . $lng['admin_panel'] . '</b></div>';
    if ($rights >= 7) {

        /*
        -----------------------------------------------------------------
        Блок модулей
        -----------------------------------------------------------------
        */
        echo'<div class="list1"><p>';
        echo'<h3><img src="../images/settings.png" width="16" height="16" class="left" />&#160;' . $lng['system'] . '</h3><ul>' .
            '<li><a href="index.php?act=forum">Tạo chuyên mục Blogs</a></li>' .
            '<li><a href="index.php?act=news">Tin Tức</a></li>' .
            '<li><a href="index.php?act=ads">Quảng Cáo</a></li>' .
            '<li><a href="index.php?act=quangcao"><font color="red">Phân phối game</font></a></li>' .
            (core::$user_rights == 9 ? '<li><a href="index.php?act=settings"><b><font color="red">' . $lng['site_settings'] . '</font></b></a></li>' : '') .
            '<li><a href="'.$home.'/users/profile.php?act=password">Thay đổi mật khẩu</a></li>' .
            '<li><a href="index.php?act=smileys">' . $lng['refresh_smileys'] . '</a></li>' .
            (core::$user_rights == 9 ? '<li><a href="index.php?act=languages">Cài đặt ngôn ngữ</a></li>' : '') .
            '<li><a href="index.php?act=access">' . $lng['access_rights'] . '</a></li>' .

            '</ul></p></div></div>';

        /*
        -----------------------------------------------------------------
        Блок безопасности
        -----------------------------------------------------------------
        */
        echo'<div class="rmenu"><p>' .
            '<h3><img src="../images/admin.png" width="16" height="16" class="left" />&#160;' . $lng['security'] . '</h3>' .
            '<ul>' .
            '<li><a href="index.php?act=antispy">' . $lng['antispy'] . '</a></li>' .
            (core::$user_rights == 9 ? '<li><a href="index.php?act=ipban">' . $lng['ip_ban'] . '</a></li>' : '') .
            '</ul>' .
            '</p></div>';
    }
}

require('../incfiles/end.php');