<?php

/**
* @package     JohnCMS
* @link        http://johncms.com
* @copyright   Copyright (C) 2008-2011 JohnCMS Community
* @license     LICENSE.txt (see attached file)
* @version     VERSION.txt (see attached file)
* @author      http://johncms.com/about
*/

defined('_IN_JOHNCMS') or die('Error: restricted access');


function seokeywords($text){
$text = html_entity_decode(trim($text), ENT_QUOTES, 'UTF-8');
 $text=str_replace(" - "," ", $text);
 $text=str_replace("  "," ", $text);
 $text=str_replace(" ",", ", $text);
 $text=str_replace("@",",",$text);
 $text=str_replace("/",",",$text);
 $text=str_replace("{","",$text);
 $text=str_replace("}","",$text);
 $text=str_replace("\\",",",$text);
 $text=str_replace(":","",$text);
 $text=str_replace("\"","",$text);
 $text=str_replace("'","",$text);
 $text=str_replace("<","",$text);
 $text=str_replace(">","",$text);
 $text=str_replace("?","",$text);
 $text=str_replace(";","",$text);
 $text=str_replace(".","",$text);
 $text=str_replace("[","",$text);
 $text=str_replace("]","",$text);
 $text=str_replace("(","",$text);
 $text=str_replace(")","",$text);
 $text=str_replace("*","",$text);
 $text=str_replace("!","",$text);
 $text=str_replace("$",",",$text);
 $text=str_replace("&",",",$text);
 $text=str_replace("%","",$text);
 $text=str_replace("#","",$text);
 $text=str_replace("^","",$text);
 $text=str_replace("=","",$text);
 $text=str_replace("+","",$text);
 $text=str_replace("~","",$text);
 $text=str_replace("`","",$text);
 $text=str_replace("--",",",$text);
 $text=str_replace("--",",",$text);
$text = preg_replace("/(à|á|ạ|ả|ã|â|ầ|ấ|ậ|ẩ|ẫ|ă|ằ|ắ|ặ|ẳ|ẵ)/", 'a', $text);
$text = preg_replace("/(à|á|ạ|ả|ã|â|ầ|ấ|ậ|ẩ|ẫ|ă|ằ|ắ|ặ|ẳ|ẵ)/", 'a', $text);

$text = preg_replace("/(è|é|ẹ|ẻ|ẽ|ê|ề|ế|ệ|ể|ễ)/", 'e', $text);

$text = preg_replace("/(è|é|ẹ|ẻ|ẽ|ê|ề|ế|ệ|ể|ễ)/", 'e', $text);

$text = preg_replace("/(ì|í|ị|ỉ|ĩ)/", 'i', $text);
$text = preg_replace("/(ì|í|ị|ỉ|ĩ)/", 'i', $text);

$text = preg_replace("/(ò|ó|ọ|ỏ|õ|ô|ồ|ố|ộ|ổ|ỗ|ơ|ờ|ớ|ợ|ở|ỡ)/", 'o', $text);
$text = preg_replace("/(ò|ó|ọ|ỏ|õ|ô|ồ|ố|ộ|ổ|ỗ|ơ|ờ|ớ|ợ|ở|ỡ)/", 'o', $text);

$text = preg_replace("/(ù|ú|ụ|ủ|ũ|ư|ừ|ứ|ự|ử|ữ)/", 'u', $text);
$text = preg_replace("/(ù|ú|ụ|ủ|ũ|ư|ừ|ứ|ự|ử|ữ)/", 'u', $text);

$text = preg_replace("/(ỳ|ý|ỵ|ỷ|ỹ)/", 'y', $text);
$text = preg_replace("/(đ)/", 'd', $text);
$text = preg_replace("/(ỳ|ý|ỵ|ỷ|ỹ)/", 'y', $text);
$text = preg_replace("/(đ)/", 'd', $text);

$text = preg_replace("/(À|Á|Ạ|Ả|Ã|Â|Ầ|Ấ|Ậ|Ẩ|Ẫ|Ă|Ằ|Ắ|Ặ|Ẳ|Ẵ)/", 'A', $text);
$text = preg_replace("/(À|Á|Ạ|Ả|Ã|Â|Ầ|Ấ|Ậ|Ẩ|Ẫ|Ă|Ằ|Ắ|Ặ|Ẳ|Ẵ)/", 'A', $text);

$text = preg_replace("/(È|É|Ẹ|Ẻ|Ẽ|Ê|Ề|Ế|Ệ|Ể|Ễ)/", 'E', $text);
$text = preg_replace("/(È|É|Ẹ|Ẻ|Ẽ|Ê|Ề|Ế|Ệ|Ể|Ễ)/", 'E', $text);

$text = preg_replace("/(Ì|Í|Ị|Ỉ|Ĩ)/", 'I', $text);
$text = preg_replace("/(Ì|Í|Ị|Ỉ|Ĩ)/", 'I', $text);

$text = preg_replace("/(Ò|Ó|Ọ|Ỏ|Õ|Ô|Ồ|Ố|Ộ|Ổ|Ỗ|Ơ|Ờ|Ớ|Ợ|Ở|Ỡ)/", 'O', $text);
$text = preg_replace("/(Ò|Ó|Ọ|Ỏ|Õ|Ô|Ồ|Ố|Ộ|Ổ|Ỗ|Ơ|Ờ|Ớ|Ợ|Ở|Ỡ)/", 'O', $text);

$text = preg_replace("/(Ù|Ú|Ụ|Ủ|Ũ|Ư|Ừ|Ứ|Ự|Ử|Ữ)/", 'U', $text);
$text = preg_replace("/(Ù|Ú|Ụ|Ủ|Ũ|Ư|Ừ|Ứ|Ự|Ử|Ữ)/", 'U', $text);

$text = preg_replace("/(Ỳ|Ý|Ỵ|Ỷ|Ỹ)/", 'Y', $text);
$text = preg_replace("/(Đ)/", 'D', $text);

$text = preg_replace("/(Ỳ|Ý|Ỵ|Ỷ|Ỹ)/", 'Y', $text);
$text = preg_replace("/(Đ)/", 'D', $text);

 $text=strtolower($text);
return $text;
}


function tags($var = '') {
$var = highlight_code($var);
$var = highlight_url($var);
global $textl, $login, $user_id;
$var = preg_replace('#\[code\](.*?)\[/code\]#si', '<div class="code">\1</div>', $var);
$var = preg_replace_callback('#\[text\](.*?)\[/text\]#si', 'khung', $var);
$var = preg_replace('#\[b\](.*?)\[/b\]#si', '<span style="font-weight: bold;">\1</span>', $var);
$var = preg_replace('#\[do\](.*?)\[/do\]#si', '<span style="font-weight: bold; color:#ffffff"><span style="background-color:#CD0000;">\1</span></span>', $var);
$var = preg_replace('#\[xa\](.*?)\[/xa\]#si', '<span style="font-weight: bold; color:#ffffff"><span style="background-color:#63C256;">\1</span></span>', $var);
$var = str_replace('[br]', '<br>', $var);
$var = str_replace('=small', '', $var);

$var = preg_replace('#\[url\](.*?)\[/url\]#si', '<a href="$1" rel="nofollow" target="_blank">$1</a>', $var);
$var = preg_replace('#\[i\](.*?)\[/i\]#si', '<span style="font-style:italic;">\1</span>', $var);
$var = preg_replace('#\[u\](.*?)\[/u\]#si', '<span style="text-decoration:underline;">\1</span>', $var);
$var = preg_replace('#\[s\](.*?)\[/s\]#si', '<span style="text-decoration: line-through;">\1</span>', $var);


$var = preg_replace('#\[phai\](.+?)\[/phai\]#is', '<div align="right">\1</div>', $var );
$var = preg_replace('#\[center\](.+?)\[/center\]#is', '<div align="center">\1</div>', $var );
$var = preg_replace('#\[CENTER\](.+?)\[/CENTER\]#is', '<div align="center">\1</div>', $var );
$var = preg_replace('#\[LEFT\](.+?)\[/LEFT\]#is', '<div align="left">\1</div>', $var );
$var = preg_replace('#\[left\](.+?)\[/left\]#is', '<div align="left">\1</div>', $var );
$var = preg_replace('#\[right\](.+?)\[/right\]#is', '<div align="right">\1</div>', $var );
$var = preg_replace('#\[RIGHT\](.+?)\[/RIGHT\]#is', '<div align="right">\1</div>', $var );
$var = preg_replace('#\[trai\](.+?)\[/trai\]#is', '<div align="left">\1</div>', $var );
$var = preg_replace('#\[giua\](.+?)\[/giua\]#is', '<div align="center">\1</div>', $var );
$var = preg_replace('#\[red\](.*?)\[/font\]#si', '<span style="color:red">\1</span>', $var);
$var = preg_replace('#\[green\](.*?)\[/font\]#si', '<span style="color:green">\1</span>', $var);
$var = preg_replace('#\[blue\](.*?)\[/font\]#si', '<span style="color:blue">\1</span>', $var);
$var = preg_replace('#\[black\](.*?)\[/font\]#si', '<span style="color:black">\1</span>', $var);
$var = preg_replace('#\[list\](.*?)\[/list\]#si', '<div style="border-top: 1px dashed #CECFCE; border-bottom: 1px dashed #CECFCE;">$1</div>', $var);
$var = preg_replace('#\[LIST\](.*?)\[/LIST\]#si', '<div style="border-top: 1px dashed #CECFCE; border-bottom: 1px dashed #CECFCE;">$1</div>', $var);

$var = preg_replace('#\[red\](.*?)\[/red\]#si', '<span style="color:red">\1</span>', $var);
$var = preg_replace('#\[green\](.*?)\[/green\]#si', '<span style="color:green">\1</span>', $var);
$var = preg_replace('#\[blue\](.*?)\[/blue\]#si', '<span style="color:blue">\1</span>', $var);
$var = preg_replace('#\[c\](.*?)\[/c\]#si', '<div class="quote">\1</div>', $var);

$var = preg_replace('#\[dl\](.*?)\[/dl\]#si', '<div class="file-attach"><div class="attach"><b>Tải Về Máy</b></div><div class="file"><div class="f">\1</div></div></div>', $var);
$var = preg_replace('#\[html\](.*?)\[/html\]#si', '<div class="bbcode_container"><div class="bbcode_description" style="padding-bottom: 2px;">HTML Code:</div><div style="width: auto; max-height: 200px; white-space: nowrap; overflow: scroll; border: 1px inset; padding: 4px; background: none repeat scroll 0% 0% rgb(242, 246, 248); text-align: left; direction: ltr;"><pre class="bbcode_code" style=""><p>\1</p></pre></div></div>', $var);

$var = preg_replace('#\[quote=(.*?)\](.*?)\[/quote\]#si', '<div class="file-attach"><div class="attach">\1</div><div class="file"><div class="f">\2</div></div></div>', $var);

$var = preg_replace('#\[img=(.+?)\]#is', '<center><img src="$1" alt="'.notags($textl).'" title="'.notags($textl).'"/></center>', $var);
$var = preg_replace('#\[img1=(.+?)\]#is', '<img src="$1" alt="'.notags($textl).'" title="'.notags($textl).'"/>', $var);
$var = preg_replace('#\[img](.+?)\[/img]#is', '<center><img src="$1" alt="'.notags($textl).'" title="'.notags($textl).'"/></center>', $var);
$var = preg_replace('#\[img=(.+?)\][/img]#is', '<center><img src="$1" alt="'.notags($textl).'" title="'.notags($textl).'"/></center>', $var);
$var = preg_replace('#\[COLOR=(.+?)\](.+?)\[/COLOR\]#is', '<font style="color:\1;">\2</font>', $var );
$var = preg_replace('#\[color=(.+?)\](.+?)\[/color\]#is', '<font style="color:\1;">\2</font>', $var );
$var = preg_replace('#\[SIZE=(.+?)\](.+?)\[/SIZE\]#is', '<font size="\1;">\2</font>', $var );
$var = preg_replace('#\[size=(.+?)\](.+?)\[/size\]#is', '<font size="\1;">\2</font>', $var );
$var = preg_replace('#\[FONT=(.+?)\](.+?)\[/FONT\]#is', '<font face="\1">\2</font>', $var );
$var = preg_replace('#\[font=(.+?)\](.+?)\[/font\]#is', '<font face="\1">\2</font>', $var );
$var = preg_replace('#\[url=(.+?)\](.+?)\[/url\]#is', '<a href="$1" rel="nofollow" target="_blank">\\2</a>', $var );
$var = preg_replace('#\[URL=(.+?)\](.+?)\[/URL\]#is', '<a href="$1" rel="nofollow" target="_blank">\\2</a>', $var );

return $var;
}


function khung($text){
$text = '<textarea rows="3">'.$text[1].'</textarea>';
$text = str_replace('<br />','', $text);
return $text;
}

function url($var) {
if (!function_exists('process_url')) {
function process_url($url) {
if (!isset($url[3])) {
if ('http://' . $tmp['host'] == core::$system_set['homeurl'] || isset(core::$user_set['direct_url']) && core::$user_set['direct_url']) {
return '<a href="' . $url[1] . '" target="_blank">' . $url[2] . '</a>';
} else {
return '<a href="' . core::$system_set['homeurl'] . '/go.php?url=' . base64_encode($url[1]) . '">' . $url[2] . '</a>';
}
} else {
$url[3] = str_replace('\"', '"', $url[3]);
return '<a href="' . $url[3] . '" target="_blank">' . auto_img(auto_title($url[3])) . '</a>';
}
}
}
$var = str_replace('[img=http://', '[img=', $var);
$var = str_replace('[img=https://', '[img=', $var);
$var = str_replace('[url=http://', '[url=', $var);
$var = str_replace('[URL=http://', '[URL=', $var);
$var = str_replace('[url=https://', '[url=', $var);
$var = str_replace('[URL=https://', '[url=', $var);
$var = str_replace('[img]http://', '[img]', $var);
$var = str_replace('[img]https://', '[img]', $var);
$var = str_replace('[IMG]http://', '[IMG]', $var);
$var = str_replace('[IMG]https://', '[IMG]', $var);
return preg_replace_callback('~\\[url=(https?://.+?)\\](.+?)\\[/url\\]|(https?://(www.)?[0-9a-z\.-]+\.[0-9a-z]{2,6}[0-9a-zA-Z/\?\.\~&amp;_=/%-:#]*)~', 'process_url', $var);
}


function highlight_url($text) {
        if (!function_exists('url_callback')) {
            function url_callback($type, $whitespace, $url, $relative_url) {
                $orig_url = $url;
                $orig_relative = $relative_url;
                $url = htmlspecialchars_decode($url);
                $relative_url = htmlspecialchars_decode($relative_url);
                $text = '';
                $chars = array('<', '>', '"');
                $split = false;
                foreach ($chars as $char) {
                    $next_split = strpos($url, $char);
                    if ($next_split !== false) {
                        $split = ($split !== false) ? min($split, $next_split) : $next_split;
                    }
                }
                if ($split !== false) {
                    $url = substr($url, 0, $split);
                    $relative_url = '';
                } else if ($relative_url) {
                    $split = false;
                    foreach ($chars as $char) {
                        $next_split = strpos($relative_url, $char);
                        if ($next_split !== false) {
                            $split = ($split !== false) ? min($split, $next_split) : $next_split;
                        }
                    }
                    if ($split !== false) {
                        $relative_url = substr($relative_url, 0, $split);
                    }
                }
                $last_char = ($relative_url) ? $relative_url[strlen($relative_url) - 1] : $url[strlen($url) - 1];
                switch ($last_char) {
                    case '.':
                    case '?':
                    case '!':
                    case ':':
                    case ',':
                        $append = $last_char;
                        if ($relative_url) $relative_url = substr($relative_url, 0, -1);
                        else $url = substr($url, 0, -1);
                        break;

                    default:
                        $append = '';
                        break;
                }
                $short_url = (mb_strlen($url) > 40) ? mb_substr($url, 0, 30) . ' ... ' . mb_substr($url, -5) : $url;
                switch ($type) {
                    case 1:
                        $relative_url = preg_replace('/[&?]sid=[0-9a-f]{32}$/', '', preg_replace('/([&?])sid=[0-9a-f]{32}&/', '$1', $relative_url));
                        $url = $url . '/' . $relative_url;
                        $text = $relative_url;
                        if (!$relative_url) {
                            return $whitespace . $orig_url . '/' . $orig_relative;
                        }
                        break;

                    case 2:
                        $text = $short_url;
                        if (!isset(core::$user_set['direct_url']) || !core::$user_set['direct_url']) {
                            $url = core::$system_set['homeurl'] . '/go.php?url=' . rawurlencode($url);
                        }
                        break;

                    case 3:
                        $url = 'http://' . $url;
                        $text = $short_url;
                        if (!isset(core::$user_set['direct_url']) || !core::$user_set['direct_url']) {
                            $url = core::$system_set['homeurl'] . '/go.php?url=' . rawurlencode($url);
                        }
                        break;

                    case 4:
                        $text = $short_url;
                        $url = 'mailto:' . $url;
                        break;
                }
                $url = htmlspecialchars($url);
                $text = htmlspecialchars($text);
                $append = htmlspecialchars($append);
                return $whitespace . '<a href="' . $url . '">' . $text . '</a>' . $append;
            }
        }

        static $url_match;
        static $url_replace;

        if (!is_array($url_match)) {
            $url_match = $url_replace = array();

            // Обработка внутренние ссылки
            $url_match[] = '#(^|[\n\t (>.])(' . preg_quote(core::$system_set['homeurl'], '#') . ')/((?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*(?:/(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*)*(?:\?(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?(?:\#(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?)#ieu';
            $url_replace[] = "url_callback(1, '\$1', '\$2', '\$3')";

            // Phát hiện dạng xxxx://aaaaa.bbb.cccc. ...
            $url_match[] = '#(^|[\n\t (>.])([a-z][a-z\d+]*:/{2}(?:(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})+|[0-9.]+|\[[a-zа-яё0-9.]+:[a-zа-яё0-9.]+:[a-zа-яё0-9.:]+\])(?::\d*)?(?:/(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*)*(?:\?(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?(?:\#(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?)#ieu';
            $url_replace[] = "url_callback(2, '\$1', '\$2', '')";

            // Phát hiện dạng "www.xxxx.yyyy[/zzzz]"
            $url_match[] = '#(^|[\n\t (>])(www\.(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})+(?::\d*)?(?:/(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@|]+|%[\dA-F]{2})*)*(?:\?(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?(?:\#(?:[a-zа-яё0-9\-._~!$&\'(*+,;=:@/?|]+|%[\dA-F]{2})*)?)#ieu';
            $url_replace[] = "url_callback(3, '\$1', '\$2', '')";

            // Phát hiện E-mail
            $url_match[] = '/(^|[\n\t (>])(([\w\!\#$\%\&\'\*\+\-\/\=\?\^\`{\|\}\~]+\.)*(?:[\w\!\#$\%\'\*\+\-\/\=\?\^\`{\|\}\~]|&amp;)+@((((([a-z0-9]{1}[a-z0-9\-]{0,62}[a-z0-9]{1})|[a-z])\.)+[a-z]{2,6})|(\d{1,3}\.){3}\d{1,3}(\:\d{1,5})?))/ie';
            $url_replace[] = "url_callback(4, '\$1', '\$2', '')";
        }
        return preg_replace($url_match, $url_replace, $text);
    }




function notags($var = '') {
$nd = array("/\[b\](.*?)\[\/b\]/is" => "$1",
"/\[i\](.*?)\[\/i\]/is" => "$1",
"/\[do\](.*?)\[\/do\]/is" => "$1",
"/\[xa\](.*?)\[\/xa\]/is" => "$1",
"/\[u\](.*?)\[\/u\]/is" => "$1",
"/\[s\](.*?)\[\/s\]/is" => "$1",
"/\[center\](.*?)\[\/center\]/is" => "$1",
"/\[download\](.*?)\[\/download\]/is" => "$1",
"/\[right\](.*?)\[\/right\]/is" => "$1",
"/\[left\](.*?)\[\/left\]/is" => "$1",
"/\[red\](.*?)\[\/red\]/is" => "$1",
"/\[blue\](.*?)\[\/blue\]/is" => "$1",
"/\[yellow\](.*?)\[\/yellow\]/is" => "$1",
"/\[green\](.*?)\[\/green\]/is" => "$1",
"/\[IMG\](.*?)\[\/IMG\]/is" => "(Hình ảnh)",
"/\[img\](.*?)\[\/img\]/is" => "(Hình ảnh)",
"/\[url\=(.*?)\](.*?)\[\/url\]/is" => "(Link tải)",
"/\[url\](.*?)\[\/url\]/is" => "(Link tải)",
"/\[color\=(.*?)\](.*?)\[\/color\]/is" => "$2",
"/\[size\=(.*?)\](.*?)\[\/size\]/is" => "$2",
"/\[quote\=(.*?)\](.*?)\[\/quote\]/is" => "$1 saild: \"$2\"",
"/\[img\=(.*?)\]/is" => "\"$1\"",
"/\[IMG\=(.*?)\]/is" => "\"$1\"",
"/\[quote\](.*?)\[\/quote\]/is" => "Trích: \"$1\"",
"/\[text\](.*?)\[\/text\]/is" => "$1",
"/\[hide\](.*?)\[\/hide\]/is" => "$1",
"/\[youtube\](.*?)\[\/youtube\]/is" => "$1");
$var = html_entity_decode($var, ENT_QUOTES, 'UTF-8');
$var = preg_replace(array_keys($nd), array_values($nd), $var);
$var = preg_replace('#\[quote=(.*?)\](.*?)\[/quote\]#si', '\2', $var);
$var = preg_replace('#"#si', '', $var);
return $var;
}

function highlight_code($vanban) {
if (!function_exists('process_code')) {
function process_code($php) {
$php = strtr($php, array('<br />' => '', '\\' => 'slash_JOHNCMS'));
$php = html_entity_decode(trim($php), ENT_QUOTES, 'UTF-8');
$php = substr($php, 0, 2) != "<?" ? "<?php\n" . $php ."\n?>" : $php;
$php = highlight_string(stripslashes($php), true);
$php = strtr($php, array('slash_JOHNCMS' => '&#92;', ':' => '&#58;', '[' => '&#91;', '<code>' => '', '</code>' => ''));
return '<div class="phpcode">'.$php.'</div>';
}
}
return preg_replace(array('#\[php\](.+?)\[/php\]#ise'), array("''.process_code('$1').''"), str_replace("]\n", "]", $vanban));
}
?>