<?php

/**
 * Code được mod bởi Phương Bách - s2demon
 * Vui lòng không xóa bản quyền để tôn trọng người viết
 **/

define('_IN_JOHNCMS', 1);

require('../incfiles/core.php');
$lng_profile = core::load_lng('profile');

/*
-----------------------------------------------------------------
Закрываем от неавторизованных юзеров
-----------------------------------------------------------------
*/
if (!$user_id) {
	header('Location: /index.php');
    exit;
}

//--- Kiểm tra xem User có tồn tại không ---//
$user = functions::get_user($user);
if (!$user) {
    require('../incfiles/head.php');
    echo functions::display_error($lng['user_does_not_exist']);
    require('../incfiles/end.php');
    exit;
}

//--- Check file ---//
$array = array(
    'edit'      => 'includes',
    'ip'        => 'includes',
    'office'    => 'includes',
    'password'  => 'includes',
    'settings'  => 'includes'
);
$path = !empty($array[$act]) ? $array[$act] . '/' : '';
if (array_key_exists($act, $array) && file_exists($path . $act . '.php')) {
    require_once($path . $act . '.php');
} else {
	header('Location: /index.php');
}

require_once('../incfiles/end.php');
?>